/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package uam.pvoe.excepciones.principal;

import java.util.Scanner;
import uam.pvoe.excepciones.excepcionespropias.MiExcepcion;

/**
 *
 * @author josue
 */
public class Principal {

    /**
     * @param args the command line arguments
     */
    public static void main(String[] args) {
        
        
        //primeraExcepcion();
        //combinandoExcepciones();
        //atrapandoExcepciones();
        //validaPropia();
        mensajesExcepciones();
    
    }
    
    
    /*Primera Excepción con Try/Catch*/
    public static void primeraExcepcion(){
        String dato = "";
        int convertido = 0;
        Scanner teclado = new Scanner(System.in);
        
        System.out.println("Introduce un número, lo leeré como cadena y lo convertiré:");
        dato = teclado.nextLine();
        
        /*Cuando se quiere convertir una cadena que no es un número a entero, 
        se produce un error
        */
        
        /*Dentro de la sentencia try se colocan las instruciones 
        que podrían generar error
        */
        try{
            convertido = Integer.parseInt(dato);
        }
        catch(Exception e){
            /*Con catch se atrapa la excepción y se puede realizar alguna acción*/
            System.out.println("El dato leído no es un número!!");
        }finally{
           System.out.println("Se ejecuta haya excepciones o no, puede servir "
                   + "para cerrar un archivo o una conexión a BD");
        }
        
         System.out.println("El dato convertido * 10 = "+convertido*10);
        
        
        
    }
    
    /*Combinando Excepciones*/
    public static void combinandoExcepciones(){
         
       String datoLeido = "";
       String datoAux = null;
       int datoConvertido;
       
       Scanner teclado = new Scanner(System.in);
       datoLeido = teclado.nextLine();
       
       if(datoLeido.length()>5){
           datoAux = "hola";
       }
       try{
           int longitud = datoAux.length(); //Puede generar un error Null Pointer
           datoConvertido = Integer.parseInt(datoAux); //Puede generar un error de conversión
       }catch(NullPointerException e){
           System.out.println("Trabajando con un valor nulo!");
       }catch (NumberFormatException e){
           System.out.println("No se pudo realizar la conversión");
       }
       
    }
    
    /*Este método atrapa una Excepción*/
    public static void atrapandoExcepciones(){
        
        try{
            System.out.println("Convertido: " + convertir("Palabra"));
        }catch(NumberFormatException e){
            System.out.println("No puedo realizar la conversión");
        }
    }
    
    
    /*Validación con una Excepción propia*/
    public static void validaPropia(){
        int n=5;
        
        try{
            minimo(n);
            System.out.println(n+ " es mayor a 10");
        }catch(MiExcepcion e){
            System.err.println(e.getMessage());
        }
    }
    
    /*Método que lanza una excepción con un mensaje diferente*/
    public static int convertir(String dato) throws NumberFormatException{
        
        int convertido = 0;
             convertido = Integer.parseInt(dato);
         return convertido;
        
        
    }
    
    /*Manejo de Excepciones*/
    public static void mensajesExcepciones(){
        
        try{
            System.out.println("Convertido: " + convertir("Hola"));
        }catch(NumberFormatException e){
            
            System.out.println("No puede realizar la conversión");
            
            System.err.println(e.getMessage());
            System.err.println(e.getCause());
            
            StackTraceElement [] errores = e.getStackTrace();
            
            for(int i=0;i<errores.length;i++){
                System.err.println("ERROR: " + errores[i].toString());
            }
        }
    }
    
    /*Método que lanza una excepción propia*/
    public static void minimo(int numero)throws MiExcepcion{
        
        if(numero <= 10){
            throw new MiExcepcion("Necesito un número mayor a 10");
        }
    }
    
  

}
